public class MyMap <T> {
    private MySet<T> keySet;
    private MyArrayList<T> valueArray;
    private int size;

    public MyMap() {
        this.size = 0;
        this.keySet = new MySet<>();
        this.valueArray = new MyArrayList<>();
    }

    public int size() {
        return size;
    }

    public boolean isEmpty() {
        if (size == 0) {
            return true;
        }
        return false;
    }

    public boolean containsKey(T key) {
        if (keySet.contains(key)) {
            return true;
        }
        return false;
    }

    public boolean containsValue(T value) {
        if (valueArray.contains(value)) {
            return true;
        }
        return false;
    }

    public void put(T key, T value) {
        if (!containsKey(key)) {
            keySet.add(key);
            valueArray.add(value);
            setSize(size + 1);
        } else {
            int index = getKeyIndex(key);
            setValue(index, value);
        }
    }

    public T get(T key) {
        for (int i = 0; i < keySet.size(); i++) {
            if (keySet.get(i) == key) {
                return valueArray.get(i);
            }
        }
        return null;
    }

    public void clear(){
        keySet.clear();
        valueArray.clear();
        setSize(0);
    }


    public void setValue(int index, T value) {
        valueArray.set(index, value);
    }

    public int getKeyIndex(T key) {
        for (int i = 0; i < keySet.size(); i++) {
            if (keySet.this.get(i) == key) {
                return i;
            }
        }
        return -1;
    }

    public MySet<T> keySet() {
        return keySet;
    }

    public MyArrayList<T> values() {
        return valueArray;
    }

    public void setSize(int size) {
        this.size = size;
    }
}